<?php
	/* 
		WideDB (PHP) Class Library
		written by M.Neset KABAKLI <neset{at}wakiza.com>
		Version : v1.3
		Notes	: --
		Licence	: GPL (General Public License) 
		
		Version History	:
		created on 2005-09-08 (1.0)
		updated on 2005-09-29 (1.1) by M.Neset KABAKLI
		updated on 2005-10-12 (1.2) by M.Neset KABAKLI
		updated on 2005-11-17 (1.3) by M.Neset KABAKLI
	*/
	
	class dbQuery {
		function execute($strsql) {
			// echo "Executing: ".$strsql." <br/>\n";
			return mysql_query($strsql);	
		}
		
		function query($strsql) {
			// echo "Querying: ".$strsql." <br/>\n";
			return mysql_query($strsql);	
		}	
		
		function queryScalar($strsql) { 
			$rs = dbQuery::query($strsql);
			if(mysql_affected_rows() > 0) {
				$row = mysql_fetch_row($rs);
				return $row[0];
			}
			return null;
		}
		
		function queryDouble($sql) {
			$r = dbQuery::queryScalar($sql);
			if($r != null)
				return (double) $r;
			return 0;
		}

		function queryInt($sql) {
			$r = dbQuery::queryScalar($sql);
			if($r != null)
				return (int) $r;
			return 0;
		}
		
		function queryString($sql) {
			$r = dbQuery::queryScalar($sql);
			if($r != null)
				return (string) $r;
			return 0;
		}
		
		// Transaction function added on 2005-09-10
		function transactionBegin() {
			$sql = "BEGIN TRANSACTION";
			if(dbQuery::execute($sql) > 0)
				return true;
			else
				return false;	
		}
		
		function transactionCommit() {
			$sql = "COMMIT";
			if(dbQuery::execute($sql) > 0)
				return true;
			else
				return false;	
		}
		
		function transactionRollback() {
			$sql = "ROLLBACK";
			if(dbQuery::execute($sql) > 0)
				return true;
			else
				return false;	
		}
	}
	
	// . . .  . . .  . . .  . . .  . . . 
	
	class dbObject {
		var $__TableName = "";
		var $__PrimaryKey = "";
		
		function dbObject() {
			$this->__PrimaryKey = "ID";	
			$this->__TableName = get_class($this);
		}
		
		// * * *  * * *  * * *  * * *  * * *  * * * 
		function getPrimaryKey() {
			return $this->__PrimaryKey;
		}

		function setPrimaryKey($strname) {
			$this->__PrimaryKey=$strname;	
		}
		
		function getPrimaryKeyValue() {
			$pk = $this->__PrimaryKey;
			return $this->$pk;	
		}

		function setPrimaryKeyValue($obj) {
			$pk = $this->__PrimaryKey;
			$this->$pk = $obj;	
			// $this->${$this->__PrimaryKey}=$obj;	
		}

		// * * *  * * *  * * *  * * *  * * *  * * * 
		// 2005-09-08, load record from the database
		function load() {
			if($this->getPrimaryKeyValue()== null || $this->getPrimaryKeyValue()== 0)			
					return false;			
			
			$sql = "SELECT * FROM {$this->__TableName} WHERE {$this->__PrimaryKey} = '".mysql_escape_string($this->getPrimaryKeyValue())."';"; 
			
			$rs = dbQuery::query($sql);
			if(mysql_affected_rows() == 0) 
				return false;
			
			$row = mysql_fetch_object($rs);
			$this->row2Object(&$row);
			return true;
		}
		
		// 2005-09-08, if not saved before insert it, otherwise update the record
		function save() {
			if($this->getPrimaryKeyValue() == null || $this->getPrimaryKeyValue() == 0)
				return $this->insert();
			else 
				return $this->update();
		}
		
		// 2005-09-08, insert record to the database
		function insert() {
			if(false && !($this->getPrimaryKeyValue() != null && $this->getPrimaryKeyValue() != 0))			
				return false;
					
			$fields = "";
			$values = "";	
			foreach(get_class_vars(get_class($this)) as $key => $value) {
				if($key[0] != "_") {
					$fields .= $key.",";
					$values .= "'".mysql_escape_string($this->$key)."',";
				}
			}		
			$fields = substr($fields,0,(strlen($fields)-1));
			$values = substr($values,0,(strlen($values)-1));
			
			
			$sql = "INSERT INTO {$this->__TableName} ({$fields}) VALUES ({$values})";
			if(dbQuery::execute($sql) <= 0)
				return false;
			
			$pk = mysql_insert_id();
			if($pk <= 0)
				return false;
				
			$this->setPrimaryKeyValue($pk);
			return true;
		}
		
		// 2005-09-08, update record on the database
		function update() {
			if(false && !($this->getPrimaryKeyValue() == null || $this->getPrimaryKeyValue() == 0))			
				return false;			
					
			$values = "";	
			foreach(get_class_vars(get_class($this)) as $key => $value) {
				if($key[0] != "_") {
					$values .= $key."='".mysql_escape_string($this->$key)."',";
				}
			}		
			$values = substr($values,0,(strlen($values)-1));
			
			$sql = "UPDATE {$this->__TableName} SET {$values} WHERE {$this->__PrimaryKey} = '".mysql_escape_string($this->getPrimaryKeyValue())."'"; 

			if(dbQuery::execute($sql) > 0)
				return true;
			else 
				return false;
		}
		
		// 2005-09-08, deletes record from the database
		function delete() {
			if(false && !($this->getPrimaryKeyValue() == null || $this->getPrimaryKeyValue() == 0))			
					return false;			

			$sql = "DELETE FROM {$this->__TableName} WHERE {$this->__PrimaryKey} = '".mysql_escape_string($this->getPrimaryKeyValue())."'"; 

			if(dbQuery::execute($sql) > 0)
				return true;
			else 
				return false;
		}	
		
		// 2005-09-10, takes values from a row which returned from a query
		function row2Object(&$row) {
			foreach(get_class_vars(get_class($this)) as $key => $value) {
				if($key[0] != "_") {
					$this->$key = stripslashes($row->$key);	
				}
			}
		}
			
		// 2005-09-10, copies itself to another dbobject			
		function copyTo(&$obj) {
			if(get_class($obj) != get_class($this))
				return false;
				
			foreach(get_class_vars(get_class($this)) as $key => $value) {
				if($key[0] != "_") {
					if($key != $this->__PrimaryKey)
						$obj->$key = $this->$key;	
				}
			}
			return true;
		}
		
		// 2005-11-17
		function reset() {
			foreach(get_class_vars(get_class($this)) as $key => $value) {
				$this->$key = $value;
			}
			return true;	
		}
	}
?>